package pw.hamzantal.shopreborn

import hazae41.minecraft.kutils.bukkit.command
import hazae41.minecraft.kutils.bukkit.listen
import hazae41.minecraft.kutils.bukkit.msg
import hazae41.minecraft.kutils.get
import net.milkbowl.vault.economy.Economy
import org.bukkit.entity.Player
import org.bukkit.plugin.java.JavaPlugin
import kotlin.system.measureTimeMillis

lateinit var econ: Economy

class ShopReborn : JavaPlugin() {

    override fun onEnable() {
        saveDefaultConfig()

        val rsp =
            server.servicesManager.getRegistration(
                Economy::class.java
            ) ?: hazae41.minecraft.kutils.error("Economy not found".c)
        econ = rsp.provider

        initConfig()

        listen(callback = ::baseListener)
        listen(callback = ::closeListener)

        command("shop") { sender, args ->
            if (sender !is Player) return@command
            if (args.isEmpty()) {
                sender.openInventory(GlobalConfig.main.inventory)
                return@command
            }

            if (args.component1() == "reload") {
                if (sender.hasPermission("shop.reload")) sender.msg("&cPlugin reloaded in ${reload()}ms.")
                else sender.msg("&cYou can't do this")
            }

            val shop = GlobalConfig.shops.firstOrNull { it.name == args.component1() } ?: return@command
            sender.openInventory(shop.inventory)
        }
    }

    fun initConfig() {
        GlobalConfig.dataFolder = dataFolder
        GlobalConfig.messages = Messages(dataFolder["messages.yml"], this)
        GlobalConfig.main =
            MainConfig(dataFolder["config.yml"])
        GlobalConfig.main.addShops()
    }

    fun reload() = measureTimeMillis {
        initConfig()
        PurchaseItems.reload()
        base.apply {
            set(18, PurchaseItems.set1)
            set(19, PurchaseItems.sub10)
            set(20, PurchaseItems.sub1)
            set(24, PurchaseItems.add1)
            set(25, PurchaseItems.add10)
            set(26, PurchaseItems.set64)
        }
    }
}